<template>
  <div>
    <!--Cabecera-->
    <section class="hero is-small is-link">
      <div class="hero-body">
        <p class="title">
          CRUD de Productos
        </p>
      </div>
    </section>

    <!--Búscador y filtros-->
    <div class="search-area">
      <nav class="level">
        <!-- Left side -->
        <div class="level-left">
          <div class="level-item">
            <div class="field has-addons">
              <p class="control is-expanded">
                <input class="input" type="text" placeholder="búsqueda de tareas..."
                  v-model="search.description"
                  style="min-width: calc(45vw)">
              </p>
              <p class="control">
                <button class="button is-link" @click.prevent="getProducto()">
                  Buscar
                </button>
              </p>
            </div>
          </div>
        </div>
        <div class="level-right">
          <modal button-title="Agregar" title="Agregar producto"
              @confirmed="onSubmit">
              <div class="form form">
                <div class="field is-horizontal">
                    <div class="field-label is-normal">
                      <label class="label">Nombre</label>
                    </div>
                    <div class="field-body">
                      <div class="field">
                        <p class="control">
                          <input class="input"
                            type="text"
                            placeholder="Ingrese un nombre para el producto"
                            v-model="addProductForm.nombre" required>
                        </p>
                      </div>
                    </div>
                </div>
                <div class="field is-horizontal">
                    <div class="field-label is-normal">
                      <label class="label">Descripción</label>
                    </div>
                    <div class="field-body">
                      <div class="field">
                        <p class="control">
                          <input class="input"
                            type="text"
                            placeholder="Ingrese una descripción para el producto"
                            v-model="addProductForm.descripcion" required>
                        </p>
                      </div>
                    </div>
                </div>
                <div class="field is-horizontal">
                    <div class="field-label is-normal">
                      <label class="label">Precio</label>
                    </div>
                    <div class="field-body">
                      <div class="field">
                        <p class="control">
                          <input class="input"
                            type="number"
                            placeholder="Ingrese un precio para el producto"
                            v-model="addProductForm.precio" required>
                        </p>
                      </div>
                    </div>
                </div>
                <div class="field is-horizontal">
                    <div class="field-label is-normal">
                      <label class="label">Estado</label>
                    </div>
                    <div class="field-body">
                      <div class="field">
                        <div class="select is-link">
                            <select v-model="addProductForm.id_estado">
                              <option v-for="(estado, index) in estadoList"
                                :key="index" :value="estado.id_estado">
                                {{ estado.nombre_estado }}
                              </option>
                            </select>
                          </div>
                      </div>
                    </div>
                </div>
                <div class="field is-horizontal">
                    <div class="field-label is-normal">
                      <label class="label">Categoria</label>
                    </div>
                    <div class="field-body">
                      <div class="field">
                        <div class="select is-link">
                            <select v-model="addProductForm.id_categoria">
                              <option v-for="(categoria, index) in categoriaList"
                                :key="index" :value="categoria.id_categoria">
                                {{ categoria.descripcion }}
                              </option>
                            </select>
                          </div>
                      </div>
                    </div>
                </div>
                <div class="field is-horizontal">
                    <div class="field-label is-normal">
                      <label class="label">Proveedor</label>
                    </div>
                    <div class="field-body">
                      <div class="field">
                        <div class="select is-link">
                            <select v-model="addProductForm.id_proveedor">
                              <option v-for="(proveedor, index) in proveedorList"
                                :key="index" :value="proveedor.id_proveedor">
                                {{ proveedor.nombre }}
                              </option>
                            </select>
                          </div>
                      </div>
                    </div>
                </div>
              </div>
          </modal>
        </div>
      </nav>
    </div>
    <br>
    <alert :message="message" v-if="showMessage"></alert>
    <br>
    <!-- Listado -->
    <div class="list-producto">
      <div class="table center">
          <thead>
              <tr>
                  <th>Producto</th>
                  <th>Descripción</th>
                  <th>Estado</th>
                  <th>Precio</th>
              </tr>
          </thead>
          <tbody>
              <tr v-for="product in productList" :key="product.id">
                <td>{{ product.nombre}} </td>
                <td>{{ product.descripcion }}</td>
                <td>{{ product._estado.nombre_estado }}</td>
                <td>{{ product.precio }}</td>
                <td>
                  <!--Editar producto existente-->
                  <modal button-class="is-info"
                      button-icon="edit"
                      button-title="Editar"
                      button-action-name="Actualizar"
                      title="Editar datos del producto"
                      @open="editProduct(product)"
                      @confirmed='onSubmitUpdate'>
                      <div class="form form">
                        <div class="field is-horizontal">
                            <div class="field-label is-normal">
                              <label class="label">Nombre</label>
                            </div>
                            <div class="field-body">
                              <div class="field">
                                <p class="control">
                                  <input class="input"
                                    type="text"
                                    placeholder="Descrpcion del producto"
                                    v-model="editForm.nombre" required>
                                </p>
                              </div>
                            </div>
                        </div>
                        <div class="field is-horizontal">
                            <div class="field-label is-normal">
                              <label class="label">Descripción</label>
                            </div>
                            <div class="field-body">
                              <div class="field">
                                <p class="control">
                                  <input class="input"
                                    type="text"
                                    placeholder="Ingrese una descripción para el producto"
                                    v-model="editForm.descripcion" required>
                                </p>
                              </div>
                            </div>
                        </div>
                        <div class="field is-horizontal">
                            <div class="field-label is-normal">
                              <label class="label">Precio</label>
                            </div>
                            <div class="field-body">
                              <div class="field">
                                <p class="control">
                                  <input class="input"
                                    type="text"
                                    placeholder="Precio del producto"
                                    v-model="editForm.precio" required>
                                </p>
                              </div>
                            </div>
                        </div>
                        <div class="field is-horizontal">
                            <div class="field-label is-normal">
                              <label class="label">Estado</label>
                            </div>
                            <div class="select is-link">
                              <select v-model="editForm.id_estado">
                                <option v-for="(estado, index) in estadoList"
                                  :key="index" :value="estado.id_estado">
                                  {{ estado.nombre_estado }}
                                </option>
                              </select>
                            </div>
                        </div>
                        <div class="field is-horizontal">
                            <div class="field-label is-normal">
                              <label class="label">Categoria</label>
                            </div>
                            <div class="select is-link">
                              <select v-model="editForm.id_categoria">
                                <option v-for="(categoria, index) in categoriaList"
                                  :key="index" :value="categoria.id_categoria">
                                  {{ categoria.descripcion }}
                                </option>
                              </select>
                            </div>
                        </div>
                        <div class="field is-horizontal">
                            <div class="field-label is-normal">
                              <label class="label">Proveedor</label>
                            </div>
                            <div class="select is-link">
                              <select v-model="editForm.id_proveedor">
                                <option v-for="(proveedor, index) in proveedorList"
                                  :key="index" :value="proveedor.id_proveedor">
                                  {{ proveedor.nombre }}
                                </option>
                              </select>
                            </div>
                        </div>
                      </div>
                  </modal>
                  <!--Borrador-->
                  <button class="button is-danger"
                    @click.prevent="onDeleteProducto(product)">Borrar
                  </button>
                </td>
              </tr>
            </tbody>
      </div>
    </div>
    <!--Paginador-->
    <div class="pagination-area">
      <pagination :page="pagination.page" :pages="pagination.pages"
        @selected="(page) => getProducto(page)">
      </pagination>
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import Alert from '../components/Alert.vue';
import Modal from '../components/Modal.vue';
import Pagination from '../components/Pagination.vue';
import {HTTP} from '@/http';

export default {
  data() {
    return {
      productList: [],
      estadoList: [],
      categoriaList: [],
      proveedorList: [],
      pagination: {
        page: 1,
        pages: 1,
      },
      addProductForm: {
        id_producto: '',
        nombre: '',
        description: '',
        precio: '',
        id_estado: '',
        id_categoria: '',
        id_proveedor: '',
      },
      editForm: {
        id_producto: '',
        nombre: '',
        descripcion: '',
        precio: '',
        id_estado: '',
        id_categoria: '',
        id_proveedor: ''
      },
      search: {
        description: null,
      },
      message: '',
      showMessage: false,
    };
  },
  components: {
    alert: Alert,
    modal: Modal,
    pagination: Pagination,
  },
  methods: {
    async getProducto(page) {
      try {
        let data = (await HTTP.post(`/search/producto`, {
          params: {
            page: page ? page : 1
          }
        })).data;
        if (data.items) {
          this.productList = data.items;
          this.pagination.page = data.page;
          this.pagination.pages = data.pages;
        } else {
          this.productList = data;
          this.pagination = {};
        }
      } catch (error) {
        //eslint-disable-next-line no-prototype-builtins
        console.log('Error');
        this.productList = [];
      }
    },
    async getEstado() {
      try {
        let data = (await HTTP.post(`/search/estado`)).data;
        if (data.items) {
          this.estadoList = data.items;
        } else {
          this.estadoList = data;
        }
      } catch (error) {
        this.estadoList = [];
      }
    },
    async getCategoria() {
      try {
        let data = (await HTTP.post(`/search/categoria`)).data;
        if (data.items) {
          this.categoriaList = data.items;
        } else {
          this.cateoriaList = data;
        }
      } catch (error) {
        this.categoriaList = [];
      }
    },
    async getProveedor() {
      try {
        let data = (await HTTP.post(`/search/proveedor`)).data;
        if (data.items) {
          this.proveedorList = data.items;
        } else {
          this.proveedorList = data;
        }
      } catch (error) {
        this.proveedorList = [];
      }
    },
    addProduct(payload) {
      const path = 'http://localhost:5000/api/producto';
      axios.post(path, payload)
        .then(() => {
          this.showMessage = true;
          this.message = 'Tarea agregada!';
          this.getProducto();
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.log(error);
          this.getProducto();
        });
    },
    initForm() {
      this.addProductForm.id_producto = '';
      this.addProductForm.nombre = '';
      this.addProductForm.descripcion = '';
      this.addProductForm.precio = '';
      this.editForm.id_estado = '';
      this.editForm.id_categoria = '';
      this.editForm.id_proveedor = '';
    },
    onSubmit() {
      const payload = {
        nombre: this.addProductForm.nombre,
        descripcion: this.addProductForm.descripcion,
        precio: this.addProductForm.precio,
        id_estado: this.addProductForm.id_estado,
        id_categoria: this.addProductForm.id_categoria,
        id_proveedor: this.addProductForm.id_proveedor,
      };
      this.addProduct(payload);
      this.initForm();
    },
    editProduct(product) {
      this.editForm = product;
    },
    onSubmitUpdate() {
      const payload = {
        id_producto: this.editForm.id_producto,
        nombre: this.editForm.nombre,
        descripcion: this.editForm.descripcion,
        precio: this.editForm.precio,
        id_estado: this.editForm.id_estado,
        id_categoria: this.editForm.id_categoria,
        id_proveedor: this.editForm.id_proveedor,
      };
      this.updateProducto(payload, this.editForm.id_producto);
      this.initForm();
    },
    updateProducto(payload, productID) {
      const path = `http://localhost:5000/api/producto/${productID}`;
      axios.put(path, payload)
        .then(() => {
          this.getProducto();
          this.message = 'Tarea actualizada!';
          this.showMessage = true;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
          this.getProducto();
        });
    },
    removeProduct(productID) {
      const path = `http://localhost:5000/api/producto/${productID}`;
      axios.delete(path)
        .then(() => {
          this.getProducto();
          this.message = 'Producto eliminado!';
          this.showMessage = true;
        })
        .catch((error) => {
          // eslint-disable-next-line
          console.error(error);
          this.getProducto();
        });
    },
    onDeleteProducto(product) {
      this.removeProduct(product.id_producto);
    },
  },
  created() {
    this.getProducto();
    this.getEstado();
    this.getCategoria();
    this.getProveedor();
  },
};
</script>

<style scoped>
.list-task {
  margin: 50px;
}
.search-area {
  margin-top: 20px;
  margin-left: 50px;
  margin-right: 50px;
}
table.center {
  margin-left:auto;
  margin-right:auto;
}
.pagination-area{
  margin: 3%;
}
</style>
